<?php echo $header; ?>

<div class="container">
    <?php echo $tabs; ?>

    <link type="text/css" href="<?php echo site_url('media/css/path.css'); ?>" rel="stylesheet">
    <div>
        <button type="button" class="btn" id="node-add"><i class="fa fa-plus-circle"></i>&nbsp;<?php echo lang('route_add_node'); ?></button>
        <button type="button" class="btn" id="node-delete"><i class="fa fa-trash"></i>&nbsp;<?php echo lang('route_delete_node'); ?></button>
        <button type="button" class="btn hide" id="path-view-return"><i class="fa fa-chevron-left"></i>&nbsp;<?php echo lang('route_back_to_main_view'); ?></button>
    </div>
    <div class="wrap">
        <div><canvas id="canvas"></canvas></div>
    </div>

    <!-- Add a Node -->
    <div id="node-add-form" class="modal hide fade">
        <div class="modal-header">
            <button type="button" id="node-add-form-dismiss" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <h3 id ="node-add-form-title"><?php echo lang('route_node_add_form_title'); ?></h3>
        </div>
        <div class="modal-body">
            <div class="hide alert alert-error" id="create_view_error"></div>
            <table style="margin: 30px 0;">
                <tr>
                    <td class="form-left" style="width: 120px;"><?php echo lang('route_node_add_form_name'); ?></td>
                    <td><input type="text" id="node-add-form-name" class="input-xlarge"></td>
                </tr>
                <tr>
                    <td class="form-left"><?php echo lang('route_node_add_form_hostname'); ?></td>
                    <td><input type="text" id="node-add-form-hostname" placeholder="192.168.0.1"></td>
                </tr>
                <tr>
                    <td class="form-left"><?php echo lang('route_node_add_form_type'); ?></td>
                    <td>
                        <select id="node-add-form-type">
                            <option value="basic"><?php echo lang('route_node_add_form_type_basic'); ?></option>
                            <option value="ncpa"><?php echo lang('route_node_add_form_type_ncpa'); ?></option>
                        </select>
                    </td>
                <tr id="node-add-form-ncpa-download-container" class="hide">
                    <td class="form-left"></td>
                    <td><a href="<?php echo site_url('media/binaries/traceroute-agent.tar.gz'); ?>"><?php echo lang('route_node_add_form_ncpa_download_message'); ?></a></td>
                </tr>
                </tr>
                <tr id="node-add-form-ncpa-token-container" class="hide">
                    <td class="form-left"><?php echo lang('route_node_add_form_ncpa_token'); ?></td>
                    <td><input type="text" id="node-add-form-ncpa-token" placeholder="mytoken"></td>
                </tr>
                <tr id="node-add-form-ncpa-port-container" class="hide">
                    <td class="form-left"><?php echo lang('route_node_add_form_ncpa_port'); ?></td>
                    <td><input type="text" id="node-add-form-ncpa-port" placeholder="5693"></td>
                </tr>
                <tr>
                    <td class="form-left"><?php echo lang('route_node_add_form_source'); ?></td>
                    <td>
                        <select id="node-add-form-source">
                            <?php foreach($nodes as $node): ?>
                                <?php if ($node['type'] !== '0'): ?>
                                    <option value="<?php echo $node['id']; ?>"><?php echo $node['name']; ?></option>
                                <?php endif; ?>
                            <?php endforeach; ?>
                        </select>
                    </td>
                </tr>
                <input type="hidden" id="node-add-form-x" name="x" />
                <input type="hidden" id="node-add-form-y" name="y" />
                <input type="hidden" id="node-add-form-edit-id" name="edit-id" />
            </table>
        </div>
        <div class="modal-footer">
            <div class="row-fluid">
                <div class="span8" style="text-align: left;">
                    <span id="node-add-form-error" class="alert alert-danger" style="display: none"></span>
                </div>
                <div class="span4">
                    <button type="button" class="btn" data-dismiss="modal" aria-hidden="true"><?php echo lang('cancel_button'); ?></button>
                    <button type="button" id="node-add-form-submit" class="btn btn-primary"><?php echo lang('submit_button'); ?></button>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete a Node -->
    <div id="node-delete-form" class="modal hide fade">
        <div class="modal-header">
            <button type="button" id="node-delete-form-dismiss" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <h3><?php echo lang('route_node_delete_form_title'); ?></h3>
        </div>
        <div class="modal-body">
            <div class="hide alert alert-error" id="create_view_error"></div>
            <p><?php echo lang('route_node_delete_form_confirm'); ?></p>
            <table style="margin: 30px 0;">
                <tr>
                    <td class="form-left" style="width: 120px;"><?php echo lang('route_node_delete_form_name'); ?></td>
                    <td><input type="text" id="node-delete-form-name" class="input-xlarge"></td>
                </tr>
                <input type="hidden" id="node-delete-form-index" name="source-id" />
                <input type="hidden" id="node-delete-form-expected-name" name="expected-name" />
            </table>
        </div>
        <div class="modal-footer">
            <div class="row-fluid">
                <div class="span8" style="text-align: left;">
                    <span id="node-delete-form-error" class="alert alert-danger" style="display: none"></span>
                </div>
                <div class="span4">
                    <button type="button" class="btn" data-dismiss="modal" aria-hidden="true"><?php echo lang('cancel_button'); ?></button>
                    <button type="button" id="node-delete-form-submit" class="btn btn-primary"><?php echo lang('delete'); ?></button>
                </div>
            </div>
        </div>
    </div>

    <script>


let hsl = (h, s, l) => `hsl(${h},${s}%,${l}%)`

let canvas = document.getElementById('canvas')
let ctx = canvas.getContext('2d')
canvas.width = window.innerWidth - 39;
canvas.height = window.innerHeight * 0.9;

canvas.style.backgroundColor = 'transparent'

class PathNode {
    constructor(id, name, hostname, x, y, numRings, reachability) {
        this.id = id
        this.name = name
        this.hostname = hostname
        this.isNode = true

        this.xStart = x;
        this.xEnd = x;
        this.xEasingFunction = (t) => t;
        this.xAnimationStart = 0;
        this.xAnimationLength = 1;
        this.x = x;

        this.yStart = y;
        this.yEnd = y;
        this.yEasingFunction = (t) => t;
        this.yAnimationStart = 0;
        this.yAnimationLength = 1;
        this.y = y;

        this.radiusStart = 20;
        this.radiusEnd = 20;
        this.radiusEasingFunction = (t) => t;
        this.radiusAnimationStart = 0;
        this.radiusAnimationLength = 1;
        this.radius = this.radiusStart;

        this.interRingStart = 5;
        this.interRingEnd = 5;
        this.interRingEasingFunction = (t) => t;
        this.interRing = this.interRingStart;
        this.interRingAnimationStart = 0;
        this.interRingAnimationLength = 1;

        this.numRings = numRings;
        this.reachability = reachability;
        this.animationStart = 0;
        this.ringAnimationOffset = 200;
        this.ringAnimationLength = 600;
        this.arcOffset = Math.random() * 6.3;
    }

    animateRadius(rStart, rEnd, tStart, tLength, easingFunction) {
        this.radiusStart = rStart;
        this.radiusEnd = rEnd;
        this.radiusAnimationStart = tStart;
        this.radiusAnimationLength = tLength;
        this.radiusEasingFunction = easingFunction;
    }

    animateInterRing(iStart, iEnd, tStart, tLength, easingFunction) {
        this.interRingStart = iStart;
        this.interRingEnd = iEnd;
        this.interRingAnimationStart = tStart;
        this.interRingAnimationLength = tLength;
        this.interRingEasingFunction = easingFunction;
    }

    setX(x) {
        this.xStart = x;
        this.xEnd = x;
        this.x = x;
    }

    setY(y) {
        this.yStart = y;
        this.yEnd = y;
        this.y = y;
    }

    animateX(xStart, xEnd, tStart, tLength, easingFunction) {
        this.xStart = xStart;
        this.xEnd = xEnd;
        this.xAnimationStart = tStart;
        this.xAnimationLength = tLength;
        this.xEasingFunction = easingFunction;
    }

    animateY(yStart, yEnd, tStart, tLength, easingFunction) {
        this.yStart = yStart;
        this.yEnd = yEnd;
        this.yAnimationStart = tStart;
        this.yAnimationLength = tLength;
        this.yEasingFunction = easingFunction;
    }

    getRenderCenter() {
        return { x: this.x + (showingPathSummary ? 0 : canvasCenter.x),
                 y: this.y + (showingPathSummary ? 0 : canvasCenter.y)};
    }

    draw(context, start, currentTime) {
        var fill_luminosity = 69; <?php // I promise this is the closest integer to the colors already present in the interface. -swolf 2023-09-26 ?>
        if (this.active || this.selected) {
            fill_luminosity = 25;
        }
        var stroke_luminosity = fill_luminosity * 0.9;
        var saturation = 100;
        var hue = 89;
        if (this.reachability == 1) { // NON-reachable. Think XI host plugin return code.
            hue = 10;
        }
        else if (this.reachability == -1) { // pending
            saturation = 0;
        }

        // TODO: clearly an Animation abstraction is in order :^)
        let radiusT = Math.min(1, Math.max(0, (((currentTime - start) - this.radiusAnimationStart) / this.radiusAnimationLength)));
        radiusT = this.radiusEasingFunction(radiusT);
        this.radius = lerp(this.radiusStart, this.radiusEnd, radiusT);

        let interRingT = Math.min(1, Math.max(0, (((currentTime - start) - this.interRingAnimationStart) / this.interRingAnimationLength)));
        interRingT = this.interRingEasingFunction(interRingT);
        this.interRing = lerp(this.interRingStart, this.interRingEnd, interRingT);

        let xT = Math.min(1, Math.max(0, (((currentTime - start) - this.xAnimationStart) / this.xAnimationLength)));
        xT = this.xEasingFunction(xT);
        this.x = lerp(this.xStart, this.xEnd, xT);

        let yT = Math.min(1, Math.max(0, (((currentTime - start) - this.yAnimationStart) / this.yAnimationLength)));
        yT = this.yEasingFunction(yT);
        this.y = lerp(this.yStart, this.yEnd, yT);

        let renderCenter = this.getRenderCenter();

        // Draw the actual filled circle
        context.fillStyle = hsl(hue, saturation, fill_luminosity);
        context.strokeStyle = hsl(hue, saturation, stroke_luminosity)
        context.lineWidth = 2;
        context.save();
        context.beginPath();
        context.arc(renderCenter.x, renderCenter.y, this.radius, 0, 6.3);
        context.closePath();
        context.fill();
        context.stroke();

        let ringT = Math.min(1, Math.max(0, (((currentTime - start) - this.animationStart) / this.radiusAnimationLength)));
        ringT = easeInOutQuart(ringT);
        let arcEnd = lerp(this.arcOffset, this.arcOffset + 6.3, ringT);

        // Draw the rings 
        context.lineWidth = 2;
        context.strokeStyle = hsl(0,0,20); // matches #333333 in top menu area
        for (var i = 0; i < this.numRings; i += 1) {
            context.beginPath();
            context.arc(renderCenter.x, renderCenter.y, this.radius + (this.interRing) * (i + 1), this.arcOffset, arcEnd);
            //context.closePath();
            context.stroke();
        }

        if (this.active) {
            this.showSummary(context)
        }
    }

    // Collision here means collision with the inner part. If someone clicks on the rings, that's their problem.
    collides(pointX, pointY) {
        let renderCenter = this.getRenderCenter();
        let distX = pointX - renderCenter.x;
        let distY = pointY - renderCenter.y;
        // kinda hacky - radius indicates "fill radius", we'd still like to collide if the mouse crosses the 'outer stroke radius'.
        let radius = this.radius + 2;

        return ((distX * distX) + (distY * distY)) < (radius * radius);
    }

    showSummary(context) {

        var fill_luminosity = 69; <?php // I promise this is the closest integer to the colors already present in the interface. -swolf 2023-09-26 ?>
        if (this.active || this.selected) {
            fill_luminosity = 25;
        }
        var stroke_luminosity = fill_luminosity * 0.9;
        var saturation = 100;
        var hue = 89;
        if (this.reachability == 1) { // NON-reachable. Think XI host plugin return code.
            hue = 10;
        }
        else if (this.reachability == -1) { // pending
            saturation = 0;
        }

        context.font = "20px Helvetica Neue,Helvetica,Arial"
        context.lineWidth = 2;
        context.fillStyle = hsl(hue, saturation, fill_luminosity);
        context.strokeStyle = hsl(hue, saturation, stroke_luminosity);

        let message = `${this.name} (${this.hostname})`;
        let bounds = ctx.measureText(message);
        bounds.height = 20; <?php // Please tell me who decided we should put a .width on TextMetrics and not .height; I would like to write to their boss. ?>

        let rightOffset =  (1 - showingPathSummary) * (this.radius + (this.interRing * this.numRings) + (bounds.width  / 2) + 10);
        let topOffset   =  (0 - showingPathSummary) * (this.radius + (this.interRing * this.numRings) + (bounds.height / 2) + 10);
        let renderCenter = this.getRenderCenter();
        context.fillText(message, renderCenter.x + rightOffset, renderCenter.y + topOffset);

    }

    select() {
        this.selected = !this.selected
    }

    activate() {
        this.active = !this.active
    }
}

function distance(src, target) {
    var distX = target.x - src.x;
    var distY = target.y - src.y;
    var distance = Math.sqrt(distX * distX + distY * distY)
    // Very large lower bound for zero checking because we're tracking pixel distances.
    return distance < 1 ? 1 : distance;
}

// Lifted from https://easings.net
function easeOutExpo(t) {
    return t >= 1 ? 1 : 1 - Math.pow(2, -10 * t);
}

function easeOutQuart(t) {
    return 1 - Math.pow(1 - t, 4)
}

function easeInOutQuart(t) {
    return t < 0.5 ? 8 * t * t * t * t : 1 - Math.pow(-2 * t + 2, 4) / 2;
}

function easeInOutBack(t) {
    const c1 = 1.70158;
    const c2 = c1 * 1.525;

    return t < 0.5
      ? (Math.pow(2 * t, 2) * ((c2 + 1) * 2 * t - c2)) / 2
      : (Math.pow(2 * t - 2, 2) * ((c2 + 1) * (t * 2 - 2) + c2) + 2) / 2;
}


function lerp(start, end, t) {
    return (1.0 - t) * start + t * end;
}

class PathIntermediate {
    constructor(hostname, reachability, output) {
        this.hostname = hostname;
        this.reachability = parseInt(reachability);
        this.output = output;
        this.active = false;
        this.visibleTime = 0;

        this.radiusStart = 15;
        this.radiusEnd = 15;
        this.radiusEasingFunction = (t) => t;
        this.radiusAnimationStart = 0;
        this.radiusAnimationLength = 1;
        this.radius = this.radiusStart;
    }

    animateRadius(rStart, rEnd, tStart, tLength, easingFunction) {
        this.radiusStart = rStart;
        this.radiusEnd = rEnd;
        this.radiusAnimationStart = tStart;
        this.radiusAnimationLength = tLength;
        this.radiusEasingFunction = easingFunction;
    }

    setX(x) { this.x = x; }
    setY(y) { this.y = y; }

    draw(context, x, y, start, currentTime) {
        if (currentTime < this.visibleTime) {
            return;
        }
        var fill_luminosity = 69; <?php // I promise this is the closest integer to the colors already present in the interface. -swolf 2023-09-26 ?>
        if (this.active || this.selected) {
            fill_luminosity = 25;
        }
        var stroke_luminosity = fill_luminosity * 0.9;
        var saturation = 100;
        var hue = 89;
        if (this.reachability == 1) { // NON-reachable. Think XI host plugin return code.
            hue = 10;
        }
        else if (this.reachability == -1) { // pending
            saturation = 0;
        }

        let radiusT = Math.min(1, Math.max(0, (((currentTime - start) - this.radiusAnimationStart) / this.radiusAnimationLength)));
        radiusT = this.radiusEasingFunction(radiusT);
        this.radius = lerp(this.radiusStart, this.radiusEnd, radiusT);

        let radius = this.radius;
        if (this.active) {
            radius *= 1.2;
        }

        context.fillStyle = hsl(hue, saturation, fill_luminosity);
        context.strokeStyle = hsl(hue, saturation, stroke_luminosity)
        context.lineWidth = 2;
        context.save();
        context.beginPath();
        context.arc(x, y, radius, 0, 6.3); // We always render this in the same spot on the page, regardless of how far we've dragged.
        context.closePath();
        context.fill();
        context.stroke();

        if (this.active) {
            context.font = "20px Helvetica Neue,Helvetica,Arial"
            let message = this.hostname + ": " + this.output + 'ms';
            if (this.hostname == '*') {
                message = "<?php echo str_replace('"', '\"', lang('route_canvas_no_response')); ?>"
            }
            context.fillText(message, x, y - 50)
        }
    }

    collides(pointX, pointY, x, y) {
        let distX = pointX - x;
        let distY = pointY - y;
        return (((distX * distX) + (distY * distY)) < (this.radius * this.radius));
    }

    activate() {
        this.active = true;
    }
}

class PathEdge {
    constructor(source, target, intermediates, animationStart) {
        this.source = source;
        this.target = target;
        this.isEdge = true;
        this.intermediates = Array.from(intermediates);
        this.lineWidth = 2; // todo: global-scope constant; match with PathNode rings.
        this.animationStart = animationStart;
        this.animationLength = 600;
    }

    setX(x) { return; }
    setY(y) { return; }

    indexOfCollidingIntermediate(pointX, pointY) {
        // Path start / end duplicated again..
        var sourceT = this.source.radius / distance(this.source, this.target);
        var targetT = 1 - (this.target.radius / distance(this.source, this.target));

        var start = { x: lerp(this.source.x, this.target.x, sourceT),
                      y: lerp(this.source.y, this.target.y, sourceT) };

        var end   = { x: lerp(this.source.x, this.target.x, targetT),
                      y: lerp(this.source.y, this.target.y, targetT) };

        for (let i = 0; i < this.intermediates.length; i += 1) {
            let int = this.intermediates[i];

            let t = (i + 1) / (this.intermediates.length + 1)
            let center = { x: lerp(start.x, end.x, t),
                           y: lerp(start.y, end.y, t) };

            if (int.collides(pointX, pointY, center.x, center.y)) {
                return i;
            }
        }

        return -1;
    }

    animateIntermediateVisibility(tStart, tLength) {
        for (let i = 0; i < this.intermediates.length; i += 1) {
            let t = (i + 1) / (this.intermediates.length + 1);
            let int = this.intermediates[i];
            let thisTStart = lerp(tStart, tStart + tLength, t);
            int.animateRadius(0, 15, thisTStart, tLength, easeOutQuart)
        }
    }

    draw(context, startTime, currentTime) {
        var fill_luminosity = 69; <?php // I promise this is the closest integer to the colors already present in the interface. -swolf 2023-09-26 ?>
        if (this.active || this.selected) {
            fill_luminosity = 25;
        }
        var stroke_luminosity = fill_luminosity * 0.9;
        var saturation = 100;
        var hue = 89;
        if (this.target.reachability == 1) { // NON-reachable. Think XI host plugin return code.
            hue = 10;
        }
        else if (this.target.reachability == -1) { // pending
            saturation = 0;
        }

        // Problem: starting lines in the middle of the circle is for suckers.
        // We want to start the lines at the edge of the circle.
        // We know that the edge is given by the radius,
        var sourceT = this.source.radius / distance(this.source, this.target);
        let endTargetT = 1 - (this.target.radius / distance(this.source, this.target));
        let targetT = Math.min(1, Math.max(0, (((currentTime - startTime) - this.animationStart) / this.animationLength)));
        targetT = easeOutQuart(targetT);
        targetT *= endTargetT;

        let sourceRenderCenter = this.source.getRenderCenter();
        let targetRenderCenter = this.target.getRenderCenter();
        var start = { x: lerp(sourceRenderCenter.x, targetRenderCenter.x, sourceT),
                      y: lerp(sourceRenderCenter.y, targetRenderCenter.y, sourceT) };

        var end   = { x: lerp(sourceRenderCenter.x, targetRenderCenter.x, targetT),
                      y: lerp(sourceRenderCenter.y, targetRenderCenter.y, targetT) };

        // Now: at the end of the line, we want to draw a small arrow pointed towards the target.
        // We'll make the arrow's height, like, equal to the target's radius? idk man.
        var arrowT = 1 - (this.target.radius * 0.6 / distance(start, end));
        var arrowPoint = { x: lerp(start.x, end.x, arrowT),
                           y: lerp(start.y, end.y, arrowT) };
        // That gets us the "base" of the arrow. To actually make "wings" we need to project perpendicular to the line.
        var perpendicular = { x: end.y - start.y,
                              y: start.x - end.x };
        var perpendicularLength = distance({x: 0, y: 0}, perpendicular);

        // Turn this guy into a unit-length vector
        var perpendicularNorm = { x: perpendicular.x / distance({x: 0, y: 0}, perpendicular),
                                   y: perpendicular.y / distance({x: 0, y: 0}, perpendicular) };
        // does this let us calculate the points?
        var arrowBaseLeft = { x: arrowPoint.x + (perpendicularNorm.x * this.target.radius * 0.25),
                              y: arrowPoint.y + (perpendicularNorm.y * this.target.radius * 0.25) };

        var arrowBaseRight = { x: arrowPoint.x - (perpendicularNorm.x * this.target.radius * 0.25),
                               y: arrowPoint.y - (perpendicularNorm.y * this.target.radius * 0.25) };

        var arrowBaseT = 1 - (this.target.radius * 0.4 / distance(start, end));
        var arrowBaseCenter = { x: lerp(start.x, end.x, arrowBaseT),
                                y: lerp(start.y, end.y, arrowBaseT) };

        //context.save();
        // Draw the arrow from node to node
        context.beginPath();
        context.moveTo(start.x          , start.y);

        if (showingPathSummary) { 
            for (let i = 0; i < this.intermediates.length; i += 1) {
                let int = this.intermediates[i];
                let t = (i + 1) / (this.intermediates.length + 1)
                let center = { x: lerp(start.x, end.x, t),
                               y: lerp(start.y, end.y, t) };
                context.lineTo(center.x, center.y)
                context.fillStyle   = hsl(int.reachability ? 10 : 89, saturation, fill_luminosity)
                context.strokeStyle = hsl(int.reachability ? 10 : 89, saturation, stroke_luminosity)
                context.lineWidth = this.lineWidth;
                context.stroke();
                context.closePath;
                context.beginPath();
                context.moveTo(center.x, center.y)
            }
        }

        context.lineTo(end.x            , end.y);
        context.lineTo(arrowBaseLeft.x  , arrowBaseLeft.y);
        context.lineTo(arrowBaseCenter.x, arrowBaseCenter.y);
        context.lineTo(arrowBaseRight.x , arrowBaseRight.y);
        context.lineTo(end.x            , end.y);
        //context.closePath();
        context.fillStyle = hsl(hue, saturation, stroke_luminosity);
        context.strokeStyle = hsl(hue, saturation, stroke_luminosity)
        context.lineWidth = this.lineWidth;
        context.stroke();
        context.fill();

        // Draw intermediate nodes.
        if (showingPathSummary) {
            for (let i = 0; i < this.intermediates.length; i += 1) {
                let int = this.intermediates[i];
                let t = (i + 1) / (this.intermediates.length + 1)
                let center = { x: lerp(start.x, end.x, t),
                               y: lerp(start.y, end.y, t) };
                int.draw(context, center.x, center.y, startTime, currentTime)
            }
        }
    }

    showSummary() {
        showingPathSummary = true;
        $('#node-add').hide()
        $('#node-delete').hide()
        $('#path-view-return').show()
        // TODO: duplicated code...
        let sourceNode = new PathNode(0, "", "", 0, 0, 0, 0);
        Object.assign(sourceNode, this.source);
        sourceNode.animateRadius(sourceNode.radius, sourceNode.radius * 3, currentTimestamp + 500, 500, easeOutQuart)
        sourceNode.animateInterRing(sourceNode.interRing, sourceNode.interRing * 3, currentTimestamp + 500, 500, easeOutQuart)
        sourceNode.animateX(sourceNode.x, canvas.width * 0.1, currentTimestamp, 600, easeOutQuart);
        sourceNode.animateY(sourceNode.y, canvas.height * 0.5, currentTimestamp, 600, easeOutQuart);

        let targetNode = new PathNode(0, "", "", 0, 0, 0, 0);
        Object.assign(targetNode, this.target);
        targetNode.animateRadius(targetNode.radius, targetNode.radius * 3, currentTimestamp + 500, 500, easeOutQuart)
        targetNode.animateInterRing(targetNode.interRing, targetNode.interRing * 3, currentTimestamp + 500, 500, easeOutQuart)
        targetNode.animateX(targetNode.x, canvas.width * 0.9, currentTimestamp, 600, easeOutQuart);
        targetNode.animateY(targetNode.y, canvas.height * 0.5, currentTimestamp, 600, easeOutQuart);

        let newEdge = new PathEdge(sourceNode, targetNode, this.intermediates, 0);
        newEdge.lineWidth *= 3;
        newEdge.animateIntermediateVisibility(currentTimestamp + 600, 600)

        pathViewParticles.push(sourceNode, targetNode, newEdge);
        return false;
    }

    collides(pointX, pointY) {
        pointX -= canvasCenter.x;
        pointY -= canvasCenter.y;
        // TODO: finding the start and end of the edge is duplicated between here and draw().
        var sourceT = this.source.radius / distance(this.source, this.target);
        var targetT = 1 - (this.target.radius / distance(this.source, this.target));

        var start = { x: lerp(this.source.x, this.target.x, sourceT),
                      y: lerp(this.source.y, this.target.y, sourceT) };

        var end   = { x: lerp(this.source.x, this.target.x, targetT),
                      y: lerp(this.source.y, this.target.y, targetT) };

        let distX = (start.x - end.x);
        let distY = (start.y - end.y);
        let distSquared = distX * distX + distY * distY;
        if (distSquared < 1) {
            distX = (start.x - pointX)
            distY = (start.y - pointY)
            if (distX * distX + distY * distY < 100) {
                return true; // TODO: hardcoded distance from line...
            }
            return false;
        }

        let t = ((pointX - start.x) * (end.x - start.x) + (pointY - start.y) * (end.y - start.y)) / distSquared;
        t = Math.max(0, Math.min(1, t)); // clamp to [0,1]
        let param = { x: start.x + t * (end.x - start.x),
                      y: start.y + t * (end.y - start.y) };

        if ((pointX - param.x) * (pointX - param.x) + (pointY - param.y) * (pointY - param.y) < 100) {
            return true;
        }

        return false;
    }

    select() {
        this.selected = !this.selected
    }

    activate() {
        this.active = !this.active
    }
}

let mouse = { x: 0, y: 0 };

/* Infinite Canvas State */
let canvasDragging = false;
let canvasCenter = { x: 0, y: 0 };
let canvasOffset = { x: 0, y: 0 };

/* Add Node button state */
const MODE_STANDARD = 0;
const MODE_ADDING_NODE = 1;
const MODE_DELETING_NODE = 2;
let mainViewMode = MODE_STANDARD;

/* Path view state */
let showingPathSummary = false;

let particleData = <?php echo json_encode($nodes); ?>;

let edgeData = <?php echo json_encode($edges); ?>;

let particles = new Array(particleData.length);
for (let i = 0; i < particleData.length; i += 1) {
    let pd = particleData[i];
    particles[i] = new PathNode(pd.id, pd.name, pd.hostname, pd.x, pd.y, pd.type, pd.reachability);
    particles[i].animateRadius(0, 20, 750 * (i + 1) / (particles.length + 1), 600, easeOutQuart)
}

let edges = new Array(edgeData.length);
for (let i = 0; i < edgeData.length; i += 1) {
    let ed = edgeData[i];
    let intermediates = new Array(ed.intermediates.length);
    for (let j = 0; j < intermediates.length; j += 1) {
        intermediates[j] = new PathIntermediate(ed.intermediates[j].hostname, 
                                                ed.intermediates[j].reachability,
                                                ed.intermediates[j].rtt);

    }
    edges[i] = new PathEdge(particles[ed.src], particles[ed.dst], intermediates, 200 + (400 * (i + 1) / (edges.length + 1)), 0)
}

// This is kind of lazy, but we want to render/update one array of things.
particles = particles.concat(edges);

// Separate node for the "Add Node" button
let pendingPathNode = new PathNode(0, "", "", 0, 0, 0, -1);
// Always instantiated immediately before drawing
let pendingPathEdge = null;

// Separate array for when we're viewing a Path Summary.
let pathViewParticles = Array(0);


let getMouseCoords = (canvas, event) => {
    let canvasCoords = canvas.getBoundingClientRect()
    return {
        x: event.clientX - canvasCoords.left,
        y: event.clientY - canvasCoords.top
    }
}

let getOffsetCoords = (mouse, rect) => {
    return {
        x: mouse.x - rect.x,
        y: mouse.y - rect.y
    }
}

// =============================================================
//                          HANDLERS
// =============================================================

$('#node-add-form-submit').on('click', function() {
    var x = parseFloat($('#node-add-form-x').val());
    var y = parseFloat($('#node-add-form-y').val());
    var id = parseInt($('#node-add-form-source').val());
    var edit_id = $('#node-add-form-edit-id').val();
    var action = 'create';
    if (edit_id !== '') {
        edit_id = parseInt(edit_id);
        action = 'update';
    }
    var name = $('#node-add-form-name').val();
    var hostname = $('#node-add-form-hostname').val()
    let source;
    for (let i = 0; i < particles.length; i += 1) {
        if (particles[i].id == id) {
            source = particles[i];
        }
    }
    var type = $('#node-add-form-type').val();
    if (type == 'basic') {
        type = 0;
    }
    else if (type == 'ncpa') {
        type = 1;
    }
    else {
        type = 2;
    }
    var token = $('#node-add-form-ncpa-token').val();
    var port = $('#node-add-form-ncpa-port').val();

    $('#node-add-form-error').css({'display': 'none'});
    var toSubmit = {
        x: x,
        y: y,
        name: name,
        hostname: hostname,
        source: source.id,
        type: type,
    };

    if (type == 1) {
        toSubmit.token = token;
        toSubmit.port = port;
    }

    if (action == 'update') {
        toSubmit.id = edit_id;
    }
    $.ajax(site_url + 'api/pathnodes/' + action, {
        data: toSubmit,
        type: 'POST', // this ought to be a PUT, but CI's form_validation library does not work with GET variables...
        success: function(data, status, xhr) {
            if (data.hasOwnProperty('error')) {
                $('#node-add-form-error').html(data.error);
                $('#node-add-form-error').css({'display': 'block'});
            }
            else {
                if (action == 'create') {
                    let newNode = new PathNode(data.id, name, hostname, x, y, type, -1);
                    particles.push(newNode);
                    let newEdge = new PathEdge(source, newNode, pendingPathEdge.intermediates, 0);
                    particles.push(newEdge);
                    if (type == 1) {
                        let sourceOption = '<option value="' + data.id + '">' + name + '</option>'; 
                        $('#node-add-form-source').append(sourceOption);
                    }
                }
                else {
                    for (let i = 0; i < particles.length; i += 1) {
                        if (particles[i].id == toSubmit.id) {
                            toModify = particles[i];
                            toModify.x = toSubmit.x;
                            toModify.y = toSubmit.y;
                            toModify.name = toSubmit.name;
                            toModify.hostname = toSubmit.hostname;
                            toModify.numRings = toSubmit.type;

                            break;
                        }
                    }

                    // Also update the source!
                    let newSource = null;
                    for (let i = 0; i < particles.length; i += 1) {
                        if (particles[i].id == toSubmit.source) {
                            newSource = particles[i];
                            break;
                        }
                    }

                    if (newSource != null) {
                        for (let i = 0; i < particles.length; i += 1) {
                            let candidateEdge = particles[i];
                            if (!candidateEdge.hasOwnProperty('isEdge')) {
                                continue;
                            }
                            if (candidateEdge.target.id == toModify.id) {
                                candidateEdge.source = newSource;
                                break;
                            }
                        }
                    }
                }

                $('#node-add-form').modal('hide');
            }
        },
        error: function(xhr, status, error) {
            $('#node-add-form-error').html(status + ': ' + error);
            $('#node-add-form-error').css({'display': 'block'});
        },
        dataType: 'json'
    });
})

$('#node-add').on('click', function() {
    if (mainViewMode == MODE_ADDING_NODE) {
        mainViewMode = MODE_STANDARD;
    }
    else {
        mainViewMode = MODE_ADDING_NODE;
    }
});

// <select> doesn't trigger a change event when you directly set the value, so...
function add_form_type_onchange(add_form_type_value)
{
    $('#node-add-form-ncpa-token-container').hide();
    $('#node-add-form-ncpa-port-container').hide();
    $('#node-add-form-ncpa-download-container').hide();
    if (add_form_type_value == 'ncpa') {
        $('#node-add-form-ncpa-token-container').show();
        $('#node-add-form-ncpa-port-container').show();
        $('#node-add-form-ncpa-download-container').show();
    }
}

$('#node-add-form-type').on('input', function(d) {

    add_form_type_onchange($(this).val());
});

$('#node-delete-form').on('hide', function() {
    mainViewMode = MODE_STANDARD;
});

$('#node-delete-form-submit').on('click', function() {
    let expectedName = $('#node-delete-form-expected-name').val();
    let actualName = $('#node-delete-form-name').val();
    if (expectedName != actualName) { return; }

    let startIndex = parseInt($('#node-delete-form-index').val());
    $('#node-delete-form-error').css({'display': 'none'});

    let frontier = [startIndex];
    let toDelete = []
    let idsToDelete = [];

    while (frontier.length > 0) {
        let currentNode = frontier[0];
        for (let i = 0; i < particles.length; i += 1) {
            let p = particles[i];
            if (p.hasOwnProperty('source') && p.source == particles[currentNode]) {
                toDelete.push(i);
                frontier.push(particles.indexOf(p.target));
            }
            if (p.hasOwnProperty('target') && p.target == particles[currentNode]) {
                toDelete.push(i);
            }
        }
        toDelete.push(currentNode)
        idsToDelete.push(particles[currentNode].id)
        frontier.shift()
    }

    toDelete = [...new Set(toDelete)];
    idsToDelete = [...new Set(idsToDelete)]
    toDelete.sort((a,b) => b-a);

    let toSubmit = { ids: idsToDelete };
    $.ajax(site_url + 'api/pathnodes/delete', {
        data: toSubmit,
        type: 'POST', // this ought to be a DELETE, but CI's form_validation library does not work with GET variables...
        dataType: 'json',
        success: function(data, status, xhr) {
            if (data.hasOwnProperty('error')) {
                $('#node-delete-form-error').html(data.error);
                $('#node-delete-form-error').css({'display': 'block'});
                return;
            }

            for (let i = 0; i < toDelete.length; i += 1) {
                particles.splice(toDelete[i],1);
            }

            $('#node-delete-form').modal('hide');
            mainViewMode = MODE_STANDARD;
        },
        error: function(xhr, status, error) {
            $('#node-add-form-error').html(status + ': ' + error);
            $('#node-add-form-error').css({'display': 'block'});
        },
    });
})

$('#node-delete').on('click', function() {
    if (mainViewMode == MODE_DELETING_NODE) {
        mainViewMode = MODE_STANDARD;
    } 
    else {
        mainViewMode = MODE_DELETING_NODE;
    }
})

$('#path-view-return').on('click', function() {
    showingPathSummary = false;
    $('#path-view-return').hide();
    $('#node-add').show();
    $('#node-delete').show()
    pathViewParticles = Array(0);
}) 

window.addEventListener('resize', () => {
    canvas.width = window.innerWidth - 39;
    canvas.height = window.innerHeight * 0.9;
})

canvas.addEventListener('mousemove', e => {
    mouse = getMouseCoords(canvas, e)

    if (showingPathSummary) {
        canvas.classList.remove('pointer')
        // TODO: hacky. Last element of the particle list is always the 'edge' (for now...)
        let edge = pathViewParticles[pathViewParticles.length-1]
        if ('indexOfCollidingIntermediate' in edge) {
            let idx = edge.indexOfCollidingIntermediate(mouse.x, mouse.y);
            if (idx >= 0) {
                edge.intermediates[idx].activate()
            }
            else {
                // Hacky. If there isn't an intermediate to show data for,
                // iterate through non-edge particles by the same logic above.
                for (let i = 0; i < pathViewParticles.length-1; i += 1) {
                    let node = pathViewParticles[i];
                    if (node.collides(mouse.x, mouse.y)) {
                        if (!node.active) {
                            node.activate();
                        }
                    }
                    else {
                        node.active = false;
                    }
                }
            }
            for (let i = 0; i < edge.intermediates.length; i += 1) {
                if ((i != idx) && edge.intermediates[i].active) {
                    edge.intermediates[i].active = false;
                }
            }
        }

        return;
    }
    let arr = particles.map(p => p.collides(mouse.x, mouse.y))
    !arr.every(p => p === false) ? canvas.classList.add('pointer') : canvas.classList.remove('pointer')

    if (mainViewMode == MODE_ADDING_NODE) {
        return;
    }

    let alreadyCollided = false;
    // TODO: why do we call collides() twice, 10 lines apart? not cool.
    for (let i = 0; i < particles.length; i += 1) {
        let p = particles[i];

        if (p.selected) {
            p.setX(mouse.x - p.offset.x)
            p.setY(mouse.y - p.offset.y)
        }

        let collides = p.collides(mouse.x, mouse.y);
        if (collides && !alreadyCollided) {
            if (!p.active) { p.activate(); }
            // if (p.hasOwnProperty("isNode")) {
            //     console.log(ctx);
            //     // This is a relatively uncool way to achieve this...
            //     p.showSummary(ctx);

            //     ctx.strokeStyle = hsl(0,0,20); // matches #333333 in top menu area
            //     ctx.fillStyle = hsl(0,0,100);
            //     ctx.fillRect(p.x+canvasCenter.x,10,p.x+canvasCenter.x+50,150);
            //     ctx.strokeRect(p.x+canvasCenter.x,10,p.x+canvasCenter.x+50,150);
            // }
            alreadyCollided = true;
        }
        else {
            p.active = false
        }
    }

    if (canvasDragging) {
        canvasCenter.x += e.movementX;
        canvasCenter.y += e.movementY;
    }
})

let mouseStart = null;
canvas.addEventListener('mousedown', e => {
    mouse = getMouseCoords(canvas, e)

    if (showingPathSummary) {
        return;
    }

    if (mainViewMode != MODE_STANDARD) { // Dragging happens only in 'standard' mode.
        return;
    }

    mouseStart = mouse;
    let sentinel = false
    for (let i = 0; i < particles.length; i += 1) {
        let p = particles[i];
        if (p.collides(mouse.x, mouse.y) && sentinel == false) {
            p.selected = true;
            p.offset = getOffsetCoords(mouse, p);
            sentinel = true;
        }
        else {
            p.selected = false;
        }
    }

    if (sentinel == false) {
        canvasDragging = true;
        canvasOffset = getOffsetCoords(mouse, canvasCenter)
    }
})

const ADD_NODE_TITLE = '<?php echo str_replace("'", "\'", lang('route_node_add_form_title')); ?>';
const EDIT_NODE_TITLE = '<?php echo str_replace("'", "\'", lang('route_node_edit_form_title')); ?>';

canvas.addEventListener('mouseup', e => {
    mouse = getMouseCoords(canvas, e)

    if (showingPathSummary) {
        return;
    }

    if (mainViewMode == MODE_ADDING_NODE) {
        // show "Add a Node" form
        mainViewMode = MODE_STANDARD;
        $('#node-add-form-title').html(ADD_NODE_TITLE);
        $('#node-add-form-name').val('');
        $('#node-add-form-hostname').val('');
        $('#node-add-form-type').val('basic');
        add_form_type_onchange('basic');
        $('#node-add-form-ncpa-token').val('');
        $('#node-add-form-ncpa-port').val('');
        $('#node-add-form-edit-id').val('');

        $('#node-add-form').modal('show');
        $('#node-add-form-x').val(mouse.x - canvasCenter.x);
        $('#node-add-form-y').val(mouse.y - canvasCenter.y);
        let idx = particles.indexOf(pendingPathEdge.source);
        $('#node-add-form-source').val(particles[idx].id);
        return;
    }

    if (mainViewMode == MODE_DELETING_NODE) {
        let found = -1;
        for (let i = 0; i < particles.length; i += 1) {
            let p = particles[i];
            if (p.active && p.id != 1) {
                found = i;
                break;
            }
        }

        if (found >= 0) {
            let foundParticle = particles[found];
            if (foundParticle.hasOwnProperty('isEdge')) {
                // Not a great way to do this, but:
                // If we tried to delete an edge, delete the targeted node instead.
                foundParticle = foundParticle.target;
                found = particles.indexOf(foundParticle);
            }
        }

        if (found >= 0) {
            $('#node-delete-form').modal('show');
            $('#node-delete-form-name').val(''); // Clear the form
            $('#node-delete-form-name-here').html(particles[found].name);
            $('#node-delete-form-expected-name').val(particles[found].name);
            $('#node-delete-form-index').val(found);
        }
    }
    else {

        let distX = mouse.x - mouseStart.x;
        let distY = mouse.y - mouseStart.y;

        for (let i = 0; i < particles.length; i += 1) {
            let p = particles[i];
            if (p.selected) {
                p.selected = false;

                if (distX * distX + distY * distY < 25 && p.id != 1) {
                    if (p.hasOwnProperty('isEdge')) {
                        // This is a relatively uncool way to do this...
                        p.showSummary(ctx);
                    }
                    else {

                        toSubmit = { id: p.id };
                        $.ajax(site_url + 'api/pathnodes/read', {
                            data: toSubmit,
                            type: 'POST',
                            dataType: 'json',
                            success: function(data, status, xhr) {
                                // We're editing a node.

                                $('#node-add-form-title').html(EDIT_NODE_TITLE);
                                $('#node-add-form-name').val(data.name);
                                $('#node-add-form-hostname').val(data.hostname);
                                switch (data.type) {
                                case '0': { $('#node-add-form-type').val('basic'); } break;
                                case '1': { $('#node-add-form-type').val('ncpa'); } break;
                                case '2': { $('#node-add-form-type').val('nna'); } break;
                                }
                                add_form_type_onchange($('#node-add-form-type').val());
                                $('#node-add-form-ncpa-token').val(data.token);
                                $('#node-add-form-ncpa-port').val(data.port);
                                $('#node-add-form-edit-id').val(data.id);
                                $('#node-add-form-source').val(data.source);

                                $('#node-add-form').modal('show');
                                $('#node-add-form-x').val(mouse.x - canvasCenter.x);
                                $('#node-add-form-y').val(mouse.y - canvasCenter.y);
                            },
                        })
                    }
                }
                else {
                    toSubmit = {
                        id: p.id,
                        x: p.x,
                        y: p.y
                    };
                    $.ajax(site_url + 'api/pathnodes/update_position', {
                        data: toSubmit,
                        type: 'POST',
                        dataType: 'json'
                    });
                }
                break;
            }
        }
    }
    canvasDragging = false;
})



// =============================================================
//                          MAIN LOOP
// =============================================================

let start, currentTimestamp;

function animate(timestamp) {
    if (start === undefined) {
        start = timestamp;
    }
    currentTimestamp = timestamp;
    ctx.clearRect(0, 0, canvas.width, canvas.height)
    ctx.fillStyle = 'white'
    ctx.textAlign = 'center'
    ctx.textBaseline = 'middle'
    if (showingPathSummary) {
        for (let i = 0; i < pathViewParticles.length; i += 1) {
            p = pathViewParticles[i];
            p.draw(ctx, start, timestamp);
        }
    }
    else { // "Default" Nodes view
        for(let i = 0; i < particles.length; i += 1) {
            p = particles[i]
            p.draw(ctx, start, timestamp)
        }

        if (mainViewMode == MODE_ADDING_NODE) {
            pendingPathNode.setX(mouse.x - canvasCenter.x);
            pendingPathNode.setY(mouse.y - canvasCenter.y);
            pendingPathNode.draw(ctx, start, timestamp);

            let minDistanceSquared = 9999999;
            let closestNode = null;
            for (let i = 0; i < particles.length; i += 1) {
                let p = particles[i];
                if (p.numRings < 1) {
                    continue;
                }

                let distX = pendingPathNode.x - p.x;
                let distY = pendingPathNode.y - p.y;
                if (distX * distX + distY * distY < minDistanceSquared) {
                    minDistanceSquared = distX * distX + distY * distY;
                    closestNode = p;
                }
            }

            pendingPathEdge = new PathEdge(closestNode, pendingPathNode, [], 0);
            pendingPathEdge.draw(ctx, start, timestamp)
        }
    }

    // Draw Legend
    ctx.lineWidth = 2;
    ctx.strokeStyle = hsl(0,0,20); // matches #333333 in top menu area
    ctx.fillStyle = hsl(0,0,100);
    ctx.fillRect(10,10,310,150);
    ctx.strokeRect(10,10,310,150);

    ctx.fillStyle = hsl(89, 0, 69);
    ctx.strokeStyle = hsl(89, 0, 69 * 0.9);
    ctx.beginPath();
    ctx.arc(30, 30, 10, 0, 6.3);
    ctx.stroke();
    ctx.fill();

    ctx.fillStyle = hsl(89, 100, 69);
    ctx.strokeStyle = hsl(89, 100, 69 * 0.9);
    ctx.beginPath();
    ctx.arc(30, 80, 10, 0, 6.3);
    ctx.stroke();
    ctx.fill();

    ctx.fillStyle = hsl(10, 100, 69);
    ctx.strokeStyle = hsl(10, 100, 69 * 0.9);
    ctx.beginPath();
    ctx.arc(30, 130, 10, 0, 6.3);
    ctx.stroke();
    ctx.fill();

    ctx.font = "18px Helvetica Neue,Helvetica,Arial"
    ctx.fillStyle = hsl(0,0,20);
    ctx.strokeStyle = hsl(0,0,20);
    let bounds;
    const pendingMessage = "<?php echo str_replace('"', '\"', lang('route_canvas_pending')); ?>";
    bounds = ctx.measureText(pendingMessage);
    ctx.fillText(pendingMessage, 50 + (bounds.width / 2), 30);
    const okMessage = "<?php echo str_replace('"', '\"', lang('route_canvas_ok')); ?>";
    bounds = ctx.measureText(okMessage)
    ctx.fillText(okMessage, 50 + (bounds.width / 2), 80)
    const unreachableMessage = "<?php echo str_replace('"', '\"', lang('route_canvas_unreachable')); ?>"; 
    bounds = ctx.measureText(unreachableMessage)
    ctx.fillText(unreachableMessage, 50 + (bounds.width / 2), 130)

    ctx.beginPath()
    ctx.arc(180, 55, 10, 0, 6.3)
    ctx.stroke()

    ctx.beginPath()
    ctx.arc(180, 105, 10, 0, 6.3)
    ctx.stroke()
    ctx.beginPath()
    ctx.arc(180, 105, 15, 0, 6.3)
    ctx.stroke()

    const ncpaMessage = "<?php echo str_replace('"', '\"', lang('route_canvas_ncpa')); ?>";
    bounds = ctx.measureText(ncpaMessage);
    ctx.fillText(ncpaMessage, 210 + (bounds.width / 2), 55)
    const nnaMessage = "<?php echo str_replace('"', '\"', lang('route_canvas_nna')); ?>";
    bounds = ctx.measureText(nnaMessage);
    ctx.fillText(nnaMessage, 210 + (bounds.width / 2), 105)

    window.requestAnimationFrame(animate)
}

animate()


    </script>
</div>

<?php echo $footer; ?>